<?php
/*
 Refine Source 1.1.3  20221120
 Copyright 2022 by Takahiro Arai. All Rights Reserved.
*/
function smarty_outputfilter_refinesource($text, $ctx) {
	$path = substr($_SERVER['REQUEST_URI'], 1);
	$path = preg_replace('%\?.*%', '', $path);
	$path = preg_replace('%/+%', '/', $path);

	if (preg_match('%\.(html|css|js|xml)|/[^\./]*$|^$%', $path)) {
		$blog = $ctx->stash('blog');
		$blog_url = $blog->site_url();
		$site_host = preg_replace("%^(.+://[^/]+).*%", "$1", $blog_url);

		// remove space
		$pattern = '%(<pre[>\s].*?</pre>)|(<textarea[>\s].*?</textarea>)|(\n)\s*%s';
		$replacement = "$1$2$3";
		$text = preg_replace($pattern, $replacement, $text);

		if (preg_match('%\.html|/[^\./]*$|^$%', $path)) {
			// convert url
			$pattern = '%<(a\s[^>]*href|img\s[^>]*src|script\s[^>]*src|link\s[^>]*href|form\s[^>]*action)="(' . $site_host . '(|/([^"]*))|/([^"]*))"%';

			$callback = function($matchs) use ($path) {
				return '<' . $matchs[1] . '="' . relLink($matchs[4] . $matchs[5], $path) . '"';
			};

			$text = preg_replace_callback($pattern, $callback, $text);
		}
	}

	return $text;
}

function relLink($url, $base_url) {
	$url_len = strlen($url);
	$comp_len = strlen($base_url);
	if($comp_len > $url_len) {
		$comp_len = $url_len;
	}

	$start_pos = 0;
	for($check_pos = 0; $check_pos < $comp_len; $check_pos++) {
		if($url[$check_pos] != $base_url[$check_pos]) {
			break;
		}
		if($url[$check_pos] == '/') {
			$start_pos = $check_pos + 1;
		}
	}

	$up_count = substr_count($base_url, '/', $start_pos);
	$rel_url = str_repeat('../', $up_count) . substr($url, $start_pos);
	if($rel_url == '') {
		$rel_url = "./";
	}
	return $rel_url;
}
?>
